<!--
    Copyright (c) 2021, Texas Instruments Incorporated
    All rights reserved.

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

    *   Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
    *   Neither the name of Texas Instruments Incorporated nor the names of
    its contributors may be used to endorse or promote products derived
    from this software without specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
    THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
    OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
    WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
    OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
    EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <title>gc-widget-message-dialog Demo</title>
    <script nomodule="" src="../../build/gc-components.js"></script>
    <script type="module" src="../../build/gc-components.esm.js"></script>
    <script type="module" src="../../gc-core-databind/lib/CoreDatabind"></script>
    <link rel="stylesheet" type="text/css" href="../../../assets/stylesheets/gc-demo-stylesheet.css">

    <style>
        #button_container {
            display: flex; flex-direction: column;
            margin-top: 20px;
        }
        #button_container gc-widget-button {
            width: 100%;
        }

        #button_container #api_title {
            --gc-font-size: 16px;
            --gc-text-align: center;
        }
    </style>
</head>

<body>
    <gc-widget-message-dialog id="demo_element">
    </gc-widget-message-dialog>

    <div id="demo_container">
        <gc-widget-button label="Open Demo Dialog" id="demoBtn"></gc-widget-button>

        <div id="button_container">
            <gc-widget-label id="api_title" label="Open dialog with API call"></gc-widget-label>
            <gc-widget-button label="Open Alert Dialog" id="demoAlertBtn" button-type="secondary"></gc-widget-button>
            <gc-widget-button label="Open Info Dialog" id="demoInfoBtn" button-type="secondary"></gc-widget-button>
            <gc-widget-button label="Open Warning Dialog" id="demoWarningBtn" button-type="secondary"></gc-widget-button>
            <gc-widget-button label="Open Error Dialog" id="demoErrorBtn" button-type="secondary"></gc-widget-button>
            <gc-widget-button label="Open Prompt Dialog" id="demoPromptBtn" button-type="secondary"></gc-widget-button>
            <gc-widget-button label="Open Progress w/o AutoClose" id="demoProgressBtn" button-type="secondary"></gc-widget-button>
            <gc-widget-button label="Open Progress AutoClose" id="demoProgressAutoCloseBtn" button-type="secondary"></gc-widget-button>
        </div>
    </div>
    <div id="demo_properties_container">
        <table>
            <tr>
                <th><gc-widget-label label="Attribute"></gc-widget-label></th>
                <th><gc-widget-label label="Value"></gc-widget-label></th>
            </tr>
            <tr>
                <td><gc-widget-label label="heading"></gc-widget-label></td>
                <td><gc-widget-input id="heading" select-on-focus placeholder="heading text" value="Heading Title"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="message"></gc-widget-label></td>
                <td><gc-widget-input id="message" select-on-focus placeholder="Enter message here..." value="Hello World!"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="icon"></gc-widget-label></td>
                <td><gc-widget-input id="icon" select-on-focus placeholder="Try action:backup..."></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="hasProgress"></gc-widget-label></td>
                <td><gc-widget-checkbox id="hasProgress"></gc-widget-checkbox></td>
            </tr>
            <tr>
                <td><gc-widget-label label="minValue"></gc-widget-label></td>
                <td><gc-widget-input id="minValue" placeholder="For progressbar" select-on-focus value="0" pattern="[0-9]*"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="maxValue"></gc-widget-label></td>
                <td><gc-widget-input id="maxValue" placeholder="For progressbar" select-on-focus value="100" pattern="[0-9]*"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="value"></gc-widget-label></td>
                <td><gc-widget-input id="value" select-on-focus placeholder="For progressbar" value="42" pattern="[0-9]*"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="hasCancel"></gc-widget-label></td>
                <td><gc-widget-checkbox id="hasCancel" checked></gc-widget-checkbox></td>
            </tr>
            <tr>
                <td><gc-widget-label label="hasOk"></gc-widget-label></td>
                <td><gc-widget-checkbox id="hasOk" checked></gc-widget-checkbox></td>
            </tr>
            <tr>
                <td><gc-widget-label label="customButtons"></gc-widget-label></td>
                <td><gc-widget-input id="customButtons"></gc-widget-input></td>
            </tr>
        </table>
    </div>
</body>
<script type="module">
    window.addEventListener('DOMContentLoaded', () => {
        const demoBtn = document.querySelector('#demoBtn');
        demoBtn.addEventListener('click', async (e) => {
            const demoElement = document.querySelector('#demo_element');
            await demoElement.open();
            demoElement.setProgressValue(document.querySelector('#value').value);
        });

        const demoProgressBtn = document.querySelector('#demoProgressBtn');
        demoProgressBtn.addEventListener('click', async () => {
            const { progress, result } = await gc.dialog.progress('Flash Device', 'Loading program on device...', 'file:file_download', true, 0, 100)
            let value = 0;
            const hdr = setInterval(() => {
                if (value <= 100) {
                    if (value === 100) progress.setMessage(`Done!`);
                    else progress.setMessage(`Completed ${value}%`);

                    progress.setValue(value++);
                } else {
                    clearInterval(hdr);
                }
            }, 10);
        });

        const demoProgressAutoCloseBtn = document.querySelector('#demoProgressAutoCloseBtn');
        demoProgressAutoCloseBtn.addEventListener('click', async () => {
            const { progress } = await gc.dialog.progress('Device Flashing', 'Loading program...', 'file:file_download', true, 0, 100, true);
            let value = 0;
            const hdr = setInterval(() => {
                if (value <= 100) {
                    progress.setValue(value++);
                    progress.setMessage(`Completed ${value}%`);
                } else {
                    clearInterval(hdr);
                }
            }, 10);

        });

        const demoPromptBtn = document.querySelector('#demoPromptBtn');
        demoPromptBtn.addEventListener('click', () => gc.dialog.prompt('Prompt', 'Prompt message...', 'action:info'));

        const demoWarningBtn = document.querySelector('#demoWarningBtn');
        demoWarningBtn.addEventListener('click', () => gc.dialog.warning('Warning message...'));

        const demoInfoBtn = document.querySelector('#demoInfoBtn');
        demoInfoBtn.addEventListener('click', () => gc.dialog.info('Info message...'));

        const demoAlertBtn = document.querySelector('#demoAlertBtn');
        demoAlertBtn.addEventListener('click', () => gc.dialog.alert('Alert message...'));

        const demoErrorBtn = document.querySelector('#demoErrorBtn');
        demoErrorBtn.addEventListener('click', () => gc.dialog.error('Error message...'));
    });
</script>

</html>